package ordered_collection_adt is
    
    generic ( type element_type is private;
              type key_type is private;
              function key_of ( e : element_type ) return key_type;
              function "<" ( l, r : key_type ) return boolean is <> );

    type ordered_collection is access private;

--    function new_ordered_collection return ordered_collection;

    procedure new_ordered_collection ( c : out ordered_collection );

    procedure insert ( c : inout ordered_collection;
                       e : in element_type );

    procedure traverse
        generic ( procedure action ( element : in element_type ) )
        ( c : in ordered_collection );

private

    -- Concrete representation is a doubly linked list
    -- with a sentinel record pointing to head and tail.

    type ordered_collection_object;
    type ordered_collection_ptr is
          access ordered_collection_object;

    type ordered_collection_object is
        record
            next_element, prev_element : ordered_collection_ptr;
            element : element_type;
        end record ordered_collection_object;

    type ordered_collection is new ordered_collection_ptr;
                                                                 
end package ordered_collection_adt;
