architecture handshake of test_bench is

    type request_message is
        record
            request_code : integer;
        end record request_message;
    
    type result_message is
        record
            result_code : integer;
        end record result_message;
    
    type request_channel is channel of request_message;
    type result_channel is channel of result_message;
    type acknowledgment_channel is null channel;
    
    channel request : request_channel;
    channel result : result_channel;
    channel request_ack, result_ack : acknowledgment_channel;

begin

    client : process is
        variable next_result : result_message;
        variable msg : request_message;
    begin
        for next_request_code in 0 to 9 loop
--            send request_message'(request_code => next_request_code)
--                to request;
            msg.request_code := next_request_code;
            send msg to request;
            receive from request_ack;
            receive next_result from result;
            send to result_ack;
        end loop;
        wait;
    end process client;


    server : process is
        variable next_request : request_message;
        variable msg : result_message;
    begin
        receive next_request from request;
        send to request_ack;
--        send result_message'( result_code => next_request.request_code )
--            to result;
        msg.result_code := next_request.request_code;
        send msg to result;
        receive from result_ack;
    end process server;

end architecture handshake;
